#!/bin/sh -x
#
# This file is part of Rheolef.
#
# Copyright (C) 2000-2009 Pierre Saramito 
#
# Rheolef is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Rheolef is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rheolef; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

DIST=${1-"debian"}
VARIANT=${2-"stable"}
ARCH=${3-"i386"}

VERSION=`cat VERSION`
if test ! -f VERSION; then
  echo "file VERSION not found."
  exit 1
fi
if test ! -f rheolef-$VERSION.tar.gz; then
  echo "file rheolef-$VERSION.tar.gz not found."
  exit 1
fi

topdir=`pwd`
builddir="/tmp/build-debian.dir"
rm -rf $builddir
mkdir $builddir
cd $builddir
cp $topdir/rheolef-$VERSION.tar.gz .
tar xpzf rheolef-$VERSION.tar.gz
cd rheolef-$VERSION
LIBRHEOLEF="librheolef$VERSION"

if test ! -d debian_dir; then
  echo "directory debian_dir not found."
  exit 1
fi
rm -f debian && ln -s debian_dir debian

if test ! -f debian/control; then
  echo "file debian/control not found."
  exit 1
fi

dpkg-buildpackage -rfakeroot -d -us -uc
sh debian/make-ftp-archive.sh $DIST $VARIANT $ARCH

debdist="rheolef-$VERSION-$DIST-$VARIANT-$ARCH.tgz"
debsrc="rheolef-$VERSION-source.tgz"
mv $debdist $debsrc $topdir

echo "! binaries are in $debdist"
echo "! sources  are in $debsrc"

