#ifndef _PROCBUF_C_H
#define _PROCBUF_C_H
///
/// This file is part of Rheolef.
///
/// Copyright (C) 2000-2009 Pierre Saramito <Pierre.Saramito@imag.fr>
///
/// Rheolef is free software; you can redistribute it and/or modify
/// it under the terms of the GNU General Public License as published by
/// the Free Software Foundation; either version 2 of the License, or
/// (at your option) any later version.
///
/// Rheolef is distributed in the hope that it will be useful,
/// but WITHOUT ANY WARRANTY; without even the implied warranty of
/// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
/// GNU General Public License for more details.
///
/// You should have received a copy of the GNU General Public License
/// along with Rheolef; if not, write to the Free Software
/// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
/// 
/// =========================================================================

#ifdef __cplusplus
extern "C" {
#endif

#include <sys/types.h> /* for pid_t */

struct procbuf_c {
    int                   fileno; // input or output
    int                   fileno1; // output, when bidirectional
    pid_t                 pid;
    struct procbuf_c*     next;
};
extern
struct procbuf_c*
proc_open (struct procbuf_c* fp, const char* command, const char* mode);

extern
int
proc_close(struct procbuf_c *fp);

extern
void
procbuf_c_init (struct procbuf_c *fp);

#ifdef __cplusplus
} // extern "C"
#endif

#endif /* _PROCBUF_C_H */
