#!/bin/sh
#
# This file is part of Rheolef.
#
# Copyright (C) 2000-2009 Pierre Saramito 
#
# Rheolef is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# Rheolef is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Rheolef; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# -------------------------------------------------------------------------
TOP_SRCDIR=${TOP_SRCDIR-"../../../rheolef"}

if [ x"${GZIP_BIN}" = x"" ]; then
    echo "can not test since GZIP_BIN is missing" 1>&2
    exit 0
fi
/bin/rm -f toto.hb toto.hb.gz

${GZIP_BIN} -dc < ${TOP_SRCDIR}/skit/tst/in-animal-s2.hb.gz > toto.hb
RHEOPATH=".:"${TOP_SRCDIR}"/skit/tst"; export RHEOPATH

echo "      RHEOPATH=.:${TOP_SRCDIR}/skit/tst ${RUN} ./irheostream_tst in-animal-s2 hb"
${RUN} ./irheostream_tst in-animal-s2 hb > tutu.hb
status=$?
if test $status -ne 0; then
    /bin/rm -f toto.hb tutu.hb
    exit $status
fi
diff toto.hb tutu.hb
status=$?

/bin/rm -f toto.hb tutu.hb
exit $status

